C*****************************************
       program write_tris
C*****************************************
       implicit none
	   include 'common.fi'
	   
       write(6,*) '=============================================='
	   write(6,*) ' THIS PROGRAM FORMS TRIANGLES FROM TRIPLE '
	   write(6,*) ' LINES AND IN-PLANE LINE SEGMENTS, CALCULATES'
	   write(6,*) ' NORMAL VECTORS, AND WRITES THE INFORMATION '     
	   write(6,*) ' IN A FORMAT SO THE GBCD CAN BE CALCULATED. '	   
	   write(6,*) ' THE REQUIRED INPUT IS FROM sort_shift.f '	 
	   write(6,*) ' AND THE OUTPUT IS triangles.txt '  
	   write(6,*)
	   write(6,*) ' DEEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 11/05/2008'
       write(6,*) '=============================================='
	   
c	   compile with gfortran main.f -o write_tris
	   
       pi = 4.0*atan(1.0)
	   total=0       ! total number of triangles

c      this reads the information in the input file 	   
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) slice
       close(21)	   
	   
	   write(6,*)'I am looking for data in the file: ',keyword
	   write(6,*) 'The thickness removed between layers is:',slice

c      here, we open the output file	   
	   open(39, file='triangles.txt', status='unknown')
	   open(32, file=keyword, status='unknown')

c  This part is to determines the total number of triple lines in the two data files

		nnline_1 = 0
 10     continue
		read(32,*,end=11)
		nnline_1=nnline_1+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I2)

		
		open(32, file=keyword, status='unknown')		

c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		

       header = 0
       hash = 0
	   do i=1,nnline_1
	    read(32, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 17     
	    endif			
	   enddo
 17   close(32)		

        n_1=int((nnline_1-header)/6)
		write(6,12) 'There are',n_1,' triple junctions in file '

		open(32, file=keyword, status='unknown')	
		
		counter = 0
		
c       here, all the triple junction data is read into a matrix

  30      format(7f9.3,f8.2,4f11.2)			
  31      format(6f9.3,4f11.4)		
         
  900     Format(8X,3F9.4)
  901     Format(8X,3F9.1)		 
  902     Format(I8)		 
		 

		do i=1,header
	     read(32, "(a)") inline
		 write(39, "(a)") inline
	    enddo

		 
		do i=1,n_1*2,2
		
         read(32,30)tri(1,1),tri(2,1),tri(3,1),tri(4,1),
     &   tri(5,1),tri(6,1),tri(7,1),tri(8,1),
     &	 tri(9,1),tri(10,1),tri(11,1),tri(12,1)
		 read(32,30)tri(1,2),tri(2,2),tri(3,2),tri(4,2),
     &   tri(5,2),tri(6,2),tri(7,2),tri(8,2),
     &	 tri(9,2),tri(10,2),tri(11,2),tri(12,2)
		 read(32,30)tri(1,3),tri(2,3),tri(3,3),tri(4,3),
     &   tri(5,3),tri(6,3),tri(7,3),tri(8,3),
     &	 tri(9,3),tri(10,3),tri(11,3),tri(12,3)
	 
         read(32,30)tri(1,4),tri(2,4),tri(3,4),tri(4,4),
     &   tri(5,4),tri(6,4),tri(7,4),tri(8,4),
     &	 tri(9,4),tri(10,4),tri(11,4),tri(12,4)
		 read(32,30)tri(1,5),tri(2,5),tri(3,5),tri(4,5),
     &   tri(5,5),tri(6,5),tri(7,5),tri(8,5),
     &	 tri(9,5),tri(10,5),tri(11,5),tri(12,5)
		 read(32,30)tri(1,6),tri(2,6),tri(3,6),tri(4,6),
     &   tri(5,6),tri(6,6),tri(7,6),tri(8,6),
     &	 tri(9,6),tri(10,6),tri(11,6),tri(12,6)	 
	 
c  The section uses the triple line and the inplane segments to get the normals		  
		  
c		  v1(1)=tri(9,1)-tri(9,4)
c		  v1(2)=tri(10,1)-tri(10,4)
c		  v1(3)=-slice
		  
		  v1(1)=tri(9,4)-tri(9,1)
		  v1(2)=tri(10,4)-tri(10,1)
		  v1(3)=slice
		  	  
		  do j=1,3
		   v2(1)=tri(11,j)-tri(9,1)
		   v2(2)=tri(12,j)-tri(10,1)
		   v2(3)=0.0
		  
		   n(1)=((v1(2)*v2(3))-(v2(2)*v1(3)))
		   n(2)=-((v1(1)*v2(3))-(v2(1)*v1(3)))
		   n(3)=((v1(1)*v2(2))-(v2(1)*v1(2)))
          
		   length=((n(1)*n(1))+(n(2)*n(2))+(n(3)*n(3)))**0.5
		   if (length.eq.0.0) then                           ! make sure you don't divide by zero
		    write(6,*),'warning: 0 n length (layer 1)',i,j
		    goto 1100
		   endif
		   
c          now we need the area.  To get this, we take half of the
c          cross product.		   
		   
		   area=0.5*length
		   
		   n(1)=n(1)/length
		   n(2)=n(2)/length
		   n(3)=n(3)/length
		   
           counter=counter+1
c          to put this in the reference frame that is consistent with the Euler angles,
c          x,y,z is writen as -y,-x,-z (the Euler anlges for this transformation are
c          -90, 180, 0).
		   write(39,31)tri(1,j), tri(2,j),tri(3,j),tri(4,j),
     &     tri(5,j),tri(6,j),-n(2),-n(1),-n(3),area

		  enddo !this is the end of the j loop over the three top segments
		  
		  do j=4,6
		   v2(1)=tri(11,j)-tri(9,4)
		   v2(2)=tri(12,j)-tri(10,4)
		   v2(3)=0.0
		  
		   n(1)=((v1(2)*v2(3))-(v2(2)*v1(3)))
		   n(2)=-((v1(1)*v2(3))-(v2(1)*v1(3)))
		   n(3)=((v1(1)*v2(2))-(v2(1)*v1(2)))
          
		   length=((n(1)*n(1))+(n(2)*n(2))+(n(3)*n(3)))**0.5
		   if (length.eq.0.0) then                           ! make sure you don't divide by zero
		    write(6,*),'warning: 0 n length (layer 1)',i,j
		    goto 1100
		   endif
		
c          now we need the area.  To get this, we take half of the
c          cross product.		   
		   
		   area=0.5*length
		   
		   n(1)=n(1)/length
		   n(2)=n(2)/length
		   n(3)=n(3)/length
		   
          counter=counter+1
c          to put this in the reference frame that is consistent with the Euler angles,
c          x,y,z is writen as -y,-x,-z (the Euler anlges for this transformation are
c          -90, 180, 0).
		   write(39,31)tri(1,j), tri(2,j),tri(3,j),tri(4,j),
     &     tri(5,j),tri(6,j),-n(2),-n(1),-n(3),area

		  enddo !this is the end of the j loop over the three bottom segments		  
		  
 1100     continue		  
	  
		  enddo !this is the end of the i loop over the triple junctions
		  
		  write(6,*)'I wrote',counter,' triangles'
 9000     continue  
        
		 close(39)
		 close(32)
        end