C*****************************************
       program match
C*****************************************
       implicit none
	   include 'common.fi'
	   
       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM FINDS TRIPLE POINTS ON ADJACENT '
	   write(6,*) ' LAYERS THAT ARE CONNECTED.  THE INPUT '
	   write(6,*) ' ARE TEXT FILES PRODUCED BY FIND_TJS. '	   
	   write(6,*) ' THESE FILE CONTAIN TRIPLETS OF LINE  '	   
	   write(6,*) ' SEGMENTS THAT MEET AT A POINT '	 
	   write(6,*) ' THE OUTPUT OF THIS PROGRAM IS A LIST '  
	   write(6,*) ' OF MATCHED TRIPLETS IN MATCH_0NN.TXT'  
	   write(6,*)
	   write(6,*) ' DEEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 11/05/2009'
       write(6,*) '=============================================='
	   
       pi = 4.0*atan(1.0)
	   total=0       ! total number of triangles
	   
c      this reads the information in the input file 	   
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) slice
       read(21,*) first
	   read(21,*) last
	   read(21,*) skip
       close(21)	   

c      this is just a check to make sure that the file
c      numbers are within the allowed bounds
       if(first.gt.98.or.last.gt.99) then
	    write(6,*) 'first and last exceed limits'
		goto 9000
	   endif	

c      this picks the appropriate
c      names for the sequential input files that list the triple junctions
c      The input files are produced by find_tjs.  These are lists of line
c      segment data in the format output by the TSL software.  Each grouping of three
c      corresponds to a triple point.  The files must have names of the type:
c      keyword_NNN.txt, where keyword is a seven character string and NNN is
c      a number between 000 and 099.

       do file_n=first,last,skip
	   if (file_n+skip.gt.last) goto 8900

	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	 	msf=int((file_n+skip)/10)
		lsf=(file_n+skip)-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
	 	open (33, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')	 

c  This part is to determines the total number of triple lines in the two data files

		nnline_1 = 0
 10     continue
		read(32,*,end=11)
		nnline_1=nnline_1+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I2)

		nnline_2 = 0
 20     continue
		read(33,*,end=21)
		nnline_2=nnline_2+1
		goto 20
 21     continue
        close(33)
 22    	format(A,I7,A,I2)

	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	 
c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		

       header = 0
       hash = 0
	   do i=1,nnline_1
	    read(32, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 25     
	    endif			
	   enddo
 25   close(32)		

        n_1=int((nnline_1-header)/3)
		write(6,12) 'There are',n_1,' triple junctions in file ',file_n		
		
		n_2=int((nnline_2-header)/3)
		write(6,22) 'There are',n_2,' triple junctions in file ',file_n+skip
		
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	 	open(39, file='matches_0'//one//two//'.txt', 
     &  status='unknown')	 
	 	msf=int((file_n+skip)/10)
		lsf=(file_n+skip)-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
	 	open (33, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	
c		open(34, file='triples_lines.txt', status='unknown')     !these are only for diognostics
c		open(35, file='x1.txt', status='unknown')
c		open(36, file='y1.txt', status='unknown')
c		open(37, file='x2.txt', status='unknown')
c		open(38, file='y2.txt', status='unknown')

		
		counter = 0
		call get_symop (3, O, nsymm)
		
c       here, all the triple junction data is read into matrices
c       If there are more than 2000 junctions in either file, then
c       the dimensions of the matrices will have to be increased.

        do i=1,header
	     read(32, "(a)") inline
		 write(39,"(a)") inline
	    enddo


 30      format(7f9.3,f8.2,4f11.2)			
         
		do i=1,n_1

         read(32,30)tri_1(1,1,i),tri_1(2,1,i),tri_1(3,1,i),tri_1(4,1,i),
     &   tri_1(5,1,i),tri_1(6,1,i),tri_1(7,1,i),tri_1(8,1,i),
     &	 tri_1(9,1,i),tri_1(10,1,i),tri_1(11,1,i),tri_1(12,1,i)
		 read(32,30)tri_1(1,2,i),tri_1(2,2,i),tri_1(3,2,i),tri_1(4,2,i),
     &   tri_1(5,2,i),tri_1(6,2,i),tri_1(7,2,i),tri_1(8,2,i),
     &	 tri_1(9,2,i),tri_1(10,2,i),tri_1(11,2,i),tri_1(12,2,i)
		 read(32,30)tri_1(1,3,i),tri_1(2,3,i),tri_1(3,3,i),tri_1(4,3,i),
     &   tri_1(5,3,i),tri_1(6,3,i),tri_1(7,3,i),tri_1(8,3,i),
     &	 tri_1(9,3,i),tri_1(10,3,i),tri_1(11,3,i),tri_1(12,3,i)
	 
	    enddo
		
	    close(32)

        do i=1,header
	     read(33, "(a)") inline
	    enddo

		
		do i=1,n_2

         read(33,30)tri_2(1,1,i),tri_2(2,1,i),tri_2(3,1,i),tri_2(4,1,i),
     &   tri_2(5,1,i),tri_2(6,1,i),tri_2(7,1,i),tri_2(8,1,i),
     &	 tri_2(9,1,i),tri_2(10,1,i),tri_2(11,1,i),tri_2(12,1,i)
		 read(33,30)tri_2(1,2,i),tri_2(2,2,i),tri_2(3,2,i),tri_2(4,2,i),
     &   tri_2(5,2,i),tri_2(6,2,i),tri_2(7,2,i),tri_2(8,2,i),
     &	 tri_2(9,2,i),tri_2(10,2,i),tri_2(11,2,i),tri_2(12,2,i)
		 read(33,30)tri_2(1,3,i),tri_2(2,3,i),tri_2(3,3,i),tri_2(4,3,i),
     &   tri_2(5,3,i),tri_2(6,3,i),tri_2(7,3,i),tri_2(8,3,i),
     &	 tri_2(9,3,i),tri_2(10,3,i),tri_2(11,3,i),tri_2(12,3,i)
	 
	    enddo
		
	    close(33)		
		
c       this is the first main loop, where triple points on layer 1
c       are matched with points on the second layer
		counter=0

		do i=1,2000     !zero the values in the triple line matrix
		 do j=1,6
		  tl(j,i)=0.0
         enddo
		enddo 
		
		do i=1,n_1

c  we start by finding the coordinate of the triple junction.  We know that 
c  one of the endpoints of the first segment must match one of the end points
c  of the second segment.  The match is the tiple point coordinate.		
		
		if(tri_1(9,1,i).eq.tri_1(9,2,i).and.tri_1(10,1,i)
     &	 .eq.tri_1(10,2,i)) then
	      tl(1,i)=tri_1(9,1,i)
		  tl(2,i)=tri_1(10,1,i)
		  goto 35
		endif
		 
        if(tri_1(9,1,i).eq.tri_1(11,2,i).and.tri_1(10,1,i)
     &	 .eq.tri_1(12,2,i)) then
	      tl(1,i)=tri_1(9,1,i)
		  tl(2,i)=tri_1(10,1,i)
		  goto 35
		endif	
c if the first coodinate doesn't match either of those from the second segment,
c then the second coordinate must be the triple point.
		
		tl(1,i)=tri_1(11,1,i)
		tl(2,i)=tri_1(12,1,i)

 35     continue
 
c in this loop, we identify the five closest tiople junction in the second layer.
c this is done by locating the each junction coordinate (as above) and then 
c calculating the distance between it and the one on the first layer.  The 
c coordinates with the shortest distances are saved in the matrix clos.
         
		 do kk=1,5
		  clos(kk,1)=200.0
		  clos(kk,2)=0.0
		 enddo

		 do j=1,n_2
 
 		if(tri_2(9,1,j).eq.tri_2(9,2,j).and.tri_2(10,1,j)
     &	 .eq.tri_2(10,2,j)) then
	      tl(3,j)=tri_2(9,1,j)
		  tl(4,j)=tri_2(10,1,j)
		  goto 36
		endif
		 
        if(tri_2(9,1,j).eq.tri_2(11,2,j).and.tri_2(10,1,j)
     &	 .eq.tri_2(12,2,j)) then
	      tl(3,j)=tri_2(9,1,j)
		  tl(4,j)=tri_2(10,1,j)
		  goto 36
		endif	
		
		tl(3,j)=tri_2(11,1,j)
		tl(4,j)=tri_2(12,1,j)

 36     continue
  
c calculate the distance between the TJ on layer 1 and the one on layer 2		
			        
		dx=tl(3,j)-tl(1,i)
        dy=tl(4,j)-tl(2,i)
		length=((dx*dx)+(dy*dy))**0.5

c This cascade rmembers the TJ if it is close

		if (length.lt.clos(1,1)) then
		 clos(1,1)=length
		 clos(1,2)=float(j)
		 clos(1,3)=tl(3,j)
		 clos(1,4)=tl(4,j)
		 goto 37
		endif 
 
 		if (length.lt.clos(2,1)) then
		 clos(2,1)=length
		 clos(2,2)=float(j)
		 clos(2,3)=tl(3,j)
		 clos(2,4)=tl(4,j)
		 goto 37
		endif 
		
		if (length.lt.clos(3,1)) then
		 clos(3,1)=length
		 clos(3,2)=float(j)
		 clos(3,3)=tl(3,j)
		 clos(3,4)=tl(4,j)
		 goto 37
		endif
		
		if (length.lt.clos(4,1)) then
		 clos(4,1)=length
		 clos(4,2)=float(j)
		 clos(4,3)=tl(3,j)
		 clos(4,4)=tl(4,j)
		 goto 37
		endif  
		 
		if (length.lt.clos(5,1)) then
		 clos(5,1)=length
		 clos(5,2)=float(j)
		 clos(5,3)=tl(3,j)
		 clos(5,4)=tl(4,j)
		 goto 37
		endif 
 37		continue	 		 

         enddo  !  this is for the j loop, that finds the five closest
		
c Next, we have to decide if any of these close ones correspond to the
c the triple junction on layer 1.

          do k=1,5
           indx=int(clos(k,2))
c we start by finding the three unique euler angles for each junction
c  We know the first two have to be different

		 e1_1(1)=tri_1(1,1,i)
		 e1_1(2)=tri_1(2,1,i)
		 e1_1(3)=tri_1(3,1,i)
		 e2_1(1)=tri_1(4,1,i)
		 e2_1(2)=tri_1(5,1,i)
		 e2_1(3)=tri_1(6,1,i)

c  If the third set has even one different compentent, then this is the one we want.

         if(tri_1(1,2,i).ne.e1_1(1).and.tri_1(1,2,i).ne.e2_1(1)) then
		   e3_1(1)=tri_1(1,2,i)
		   e3_1(2)=tri_1(2,2,i)
		   e3_1(3)=tri_1(3,2,i)
		   goto 38
		  endif 
		 
		  if(tri_1(2,2,i).ne.e1_1(2).and.tri_1(2,2,i).ne.e2_1(2)) then
		   e3_1(1)=tri_1(1,2,i)
		   e3_1(2)=tri_1(2,2,i)
		   e3_1(3)=tri_1(3,2,i)
		   goto 38
		  endif		  
		
		  if(tri_1(3,2,i).ne.e1_1(3).and.tri_1(3,2,i).ne.e2_1(3)) then
		   e3_1(1)=tri_1(1,2,i)
		   e3_1(2)=tri_1(2,2,i)
		   e3_1(3)=tri_1(3,2,i)
		   goto 38
		  endif
  
c  If the components of the third all matched components in the first two, then
c  the fourth one must be the one we want.

		 e3_1(1)=tri_1(4,2,i)
		 e3_1(2)=tri_1(5,2,i)
		 e3_1(3)=tri_1(6,2,i)
 38      continue		 
c now we repeat this on the second layer

		 e1_2(1)=tri_2(1,1,indx)
		 e1_2(2)=tri_2(2,1,indx)
		 e1_2(3)=tri_2(3,1,indx)
		 e2_2(1)=tri_2(4,1,indx)
		 e2_2(2)=tri_2(5,1,indx)
		 e2_2(3)=tri_2(6,1,indx)

         if(tri_2(1,2,indx).ne.e1_2(1).and.tri_2(1,2,indx).ne.e2_2(1)) then
		   e3_2(1)=tri_2(1,2,indx)
		   e3_2(2)=tri_2(2,2,indx)
		   e3_2(3)=tri_2(3,2,indx)
		   goto 39
		  endif 
		 
		  if(tri_2(2,2,indx).ne.e1_2(2).and.tri_2(2,2,indx).ne.e2_2(2)) then
		   e3_2(1)=tri_2(1,2,indx)
		   e3_2(2)=tri_2(2,2,indx)
		   e3_2(3)=tri_2(3,2,indx)
		   goto 39
		  endif		  
		
		  if(tri_2(3,2,indx).ne.e1_2(3).and.tri_2(3,2,indx).ne.e2_2(3)) then
		   e3_2(1)=tri_2(1,2,indx)
		   e3_2(2)=tri_2(2,2,indx)
		   e3_2(3)=tri_2(3,2,indx)
		   goto 39
		  endif

		 e3_2(1)=tri_2(4,2,indx)
		 e3_2(2)=tri_2(5,2,indx)
		 e3_2(3)=tri_2(6,2,indx)
 39      continue			  
 
 
c        the converts the Euler angles to orientations

         call EToG(e1_1,g1_1)
		 call EToG(e2_1,g2_1)
		 call EToG(e3_1,g3_1) 
		 call EToG(e1_2,g1_2)
		 call EToG(e2_2,g2_2)
		 call EToG(e3_2,g3_2) 
 
c        next, we want to determine the minumum misorientation between
c        the grains around the first TJ and those around the second one 

         min_disor(1) = pi
         min_disor(2) = pi
         min_disor(3) = pi		  

c        first, find the one on the second layer that has the minimum misorientation
c        with the one on the first

c        first, we find the disorientation between the first grain on layer one and
c        all three grains on layer two, keeping the minimum one
           
		   do i_s=1,nsymm	  	!grain 1 on layer 1 and grain 1 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g1_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 
           enddo
		  enddo
 
 		   do i_s=1,nsymm	!grain 1 on layer 1 and grain 2 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 
           enddo
		  enddo
 
  		   do i_s=1,nsymm	!grain 1 on layer 1 and grain 3 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g3_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		        misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1)) then
				min_disor(1)=misor
			   endif 
           enddo
		  enddo
 
c        next, we find the disorientation between the second grain on layer one and
c        all three grains on layer two, keeping the minimum one
 
 		   do i_s=1,nsymm	!grain 2 on layer 1 and grain 1 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g2_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g1_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
			    misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif 
           enddo
		  enddo
 
 		   do i_s=1,nsymm	!grain 2 on layer 1 and grain 2 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g2_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
			    misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif 
           enddo
		  enddo
 
  		   do i_s=1,nsymm	!grain 2 on layer 1 and grain 3 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g2_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g3_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		        misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2)) then
				min_disor(2)=misor
			   endif  
           enddo
		  enddo
 
c        next, we find the disorientation between the third grain on layer one and
c        all three grains on layer two, keeping the minimum one
 
  		   do i_s=1,nsymm	!grain 3 on layer 1 and grain 1 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g3_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g1_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		    	misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif  
           enddo
		  enddo
 
 		   do i_s=1,nsymm		!grain 3 on layer 1 and grain 2 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g3_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		       misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif 
           enddo
		  enddo
 
  		   do i_s=1,nsymm		!grain 3 on layer 1 and grain 3 on layer 2
		    call symop(O,i_s,so1)
		    call MToM (so1,g3_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g3_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		       misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3)) then
				min_disor(3)=misor
			   endif 
           enddo
		  enddo
 
 500     format(f5.2,1x,f5.2,1x,f5.2,1x,f5.2,1x,f5.0,1x,f5.0)

         if (min_disor(1).lt.0.0873.and.min_disor(2).lt.0.0873
     &     .and.min_disor(3).lt.0.0873) then
	         counter=counter+1
		     tl(3,i)=clos(k,3)
		     tl(4,i)=clos(k,4)
			 tl(5,i)=float(i)
			 tl(6,i)=float(indx)

		 write(39,30)tri_1(1,1,i),tri_1(2,1,i),tri_1(3,1,i),tri_1(4,1,i),
     &   tri_1(5,1,i),tri_1(6,1,i),tri_1(7,1,i),tri_1(8,1,i),
     &	 tri_1(9,1,i),tri_1(10,1,i),tri_1(11,1,i),tri_1(12,1,i)
		 write(39,30)tri_1(1,2,i),tri_1(2,2,i),tri_1(3,2,i),tri_1(4,2,i),
     &   tri_1(5,2,i),tri_1(6,2,i),tri_1(7,2,i),tri_1(8,2,i),
     &	 tri_1(9,2,i),tri_1(10,2,i),tri_1(11,2,i),tri_1(12,2,i)
		 write(39,30)tri_1(1,3,i),tri_1(2,3,i),tri_1(3,3,i),tri_1(4,3,i),
     &   tri_1(5,3,i),tri_1(6,3,i),tri_1(7,3,i),tri_1(8,3,i),
     &	 tri_1(9,3,i),tri_1(10,3,i),tri_1(11,3,i),tri_1(12,3,i)
		 kk=indx
		 write(39,30)tri_2(1,1,kk),tri_2(2,1,kk),tri_2(3,1,kk),tri_2(4,1,kk),
     &   tri_2(5,1,kk),tri_2(6,1,kk),tri_2(7,1,kk),tri_2(8,1,kk),
     &	 tri_2(9,1,kk),tri_2(10,1,kk),tri_2(11,1,kk),tri_2(12,1,kk)
		 write(39,30)tri_2(1,2,kk),tri_2(2,2,kk),tri_2(3,2,kk),tri_2(4,2,kk),
     &   tri_2(5,2,kk),tri_2(6,2,kk),tri_2(7,2,kk),tri_2(8,2,kk),
     &	 tri_2(9,2,kk),tri_2(10,2,kk),tri_2(11,2,kk),tri_2(12,2,kk)
		 write(39,30)tri_2(1,3,kk),tri_2(2,3,kk),tri_2(3,3,kk),tri_2(4,3,kk),
     &   tri_2(5,3,kk),tri_2(6,3,kk),tri_2(7,3,kk),tri_2(8,3,kk),
     &	 tri_2(9,3,kk),tri_2(10,3,kk),tri_2(11,3,kk),tri_2(12,3,kk)
	 		 
c			 tls(1,counter)=tl(1,i)
c            tls(2,counter)=tl(2,i)
c			 tls(3,counter)=tl(3,i)
c			 tls(4,counter)=tl(4,i)
c			 tls(5,counter)=tl(5,i)
c			 tls(6,counter)=tl(6,i)
c            this will output the triple junction coordinates
c            write(34,500) tl(1,i),tl(2,i),tl(3,i),tl(4,i),tl(5,i),tl(6,i)
c			 write(35,*)tl(1,i)
c			 write(36,*)tl(2,i)
c			 write(37,*)tl(3,i)
c			 write(38,*)tl(4,i)
             goto 1000
		endif	

		  
		  enddo       ! this is the k loop, over the five closest


 1000   continue						
		enddo         ! this is the i loop

		 
		 write(6,*)'I found and wrote',counter,'matched triple junctions'

c The matrix tls contains TJ xy on layer one, TJ xy on layer 2, then the indices of the
c of the triple junction on layer one and layer two.  


 8900	close(39)
        enddo                 ! This is the end of the file_n looop

 9000     continue  
        

c		 close(34)
c		 close(35)
c		 close(36)
c		 close(37)
c		 close(38)

		 
        end