C*****************************************
       program sort_shift
C*****************************************
       implicit none
	   include 'common.fi'

       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM ORGANIZES TRIPLE JUNCTION DATA '
	   write(6,*) ' SO THAT EACH OF THE SEGMENTS AROUND AT '
	   write(6,*) ' IS WRITTEN IN CCW ORDER AROUND THE TRIPLE '	   
	   write(6,*) ' LINE DIRECTION AND HAS SET OF EULER ANGLES.  '	   
	   write(6,*) ' AS INPUT, FILES FROM match.f ARE REQUIRED '	 
	   write(6,*) ' THE OUTPUT OF THIS PROGRAM IS A LIST '  
	   write(6,*) ' OF FORMATTED JUNCTION DATA IN tls.txt '  
	   write(6,*) ' THE PROGRAM ALSO APPLIES A RIGID SHIFT '	   
	   write(6,*) ' UNDER THE ASSUMPTION THAT TJs ARE RANDOMLY '
	   write(6,*) ' DISTRIBUTED ABOUT THE NORMAL DIRECTION AND '
	   write(6,*) ' THIS DATA ARE WRITTEN TO tls_shifted.txt '	   	   	   
	   write(6,*)
	   write(6,*) ' DEVELOPED BY CMU MRSEC'
	   write(6,*) '  version 11/05/2009'
       write(6,*) '=============================================='
	
       pi = 4.0*atan(1.0)
	   ok=0
	   bad=0  
	   
	   r_count=0
	   do j=1,10000
		good(j)=0.0
	   enddo

       open(39, file='tls.txt', status='unknown')
	   open(55, file='tls_shifted.txt', status='unknown')
	   open(56, file='shift.txt', status='unknown')

c      this reads the information in the input file 	   
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) slice
	   read(21,*) keep
       read(21,*) first
	   read(21,*) last
       close(21)	   

c      this is just a check to make sure that the file
c      numbers are within the allowed bounds
       if(first.gt.98.or.last.gt.99) then
	    write(6,*) 'first and last exceed limits'
		goto 9000
	   endif	

c      this long mess of conditionals picks the appropriate
c      names for the sequential input files that list matches
c      The input files are produced by match.f.  These are lists of line
c      segment data in the format output by the TSL software.  Each grouping of six
c      corresponds to the three segments on the top layer of a triple line and
c      the three segments on the bottom layer of a triple line.  The files must 
c      have names of the type:  keyword_NNN.txt, where keyword is a seven 
c      character string and NNN is a number between 000 and 099.

       do file_n=first,last-1

	   tot_x=0
	   tot_y=0
	   mean_x=0
	   mean_y=0	 

	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 8
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 8
	   endif	   
	   
	   	if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')	 
	    goto 8
	   endif
	   
 8     continue	 

c  This part is to determines the total number of triple lines in each data files

		nnline_1 = 0
 10     continue
		read(32,*,end=11)
		nnline_1=nnline_1+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I2)



	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
		goto 15
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 15
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 15
	   endif	   
	   
	   	if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')	 
	    goto 15
	   endif
	   
 15     continue	 


c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		

       header = 0
       hash = 0
	   do i=1,nnline_1
	    read(32, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 17     
	    endif			
	   enddo
 17   close(32)		


        n_1=int((nnline_1-header)/6)
		write(6,12) 'There are',n_1,' triple junctions in file ',file_n




			
c      this long mess of conditionals picks (again) the appropriate
c      names for the sequential files listing triple junctions		


	   if (file_n.eq.0) then
	    one=char(48)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')	
		goto 28
	   endif
	   
	   if (file_n.gt.0.and.file_n.lt.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')
	    goto 28
	   endif		   
	   
	   if (file_n.eq.9) then
	    one=char(48+file_n)
		open (32, file=keyword//'_00'//one//'.txt'
     &         ,status='unknown')	 
	    goto 28
	   endif	   
	   
	   	if (file_n.gt.9.and.file_n.lt.99) then
	    msf=int(file_n/10)
		lsf=file_n-(10*msf)
		one=char(48+msf)
		two=char(48+lsf)
		open (32, file=keyword//'_0'//one//two//'.txt'
     &         ,status='unknown')
	    goto 28
	   endif
	   
 28     continue	 
	
c		open(34, file='triples_lines.txt', status='unknown')     !these are only for diognostics
c		open(35, file='x1.txt', status='unknown')
c		open(36, file='y1.txt', status='unknown')
c		open(37, file='x2.txt', status='unknown')
c		open(38, file='y2.txt', status='unknown')

		counter = 0
		call get_symop (3, O, nsymm)
		

		do i=1,2000     !zero the values in the triple line matrix
		 do j=1,6
		  tl(j,i)=0.0
         enddo
		enddo 		
		
c       here, all the triple junction data is read into matrices.
c       If there are more than 2000 junctions, then
c       the dimensions of the matrices will have to be increased.

 30      format(7f9.3,f8.2,4f11.2)			
         
		 
		do i=1,header
	     read(32, "(a)") inline
		 if (file_n.eq.first) then
		 write(39, "(a)") inline
		 write(55, "(a)") inline
		 endif
	    enddo
 
		 
		do i=1,n_1
		
         read(32,30)tri_1(1,1,i),tri_1(2,1,i),tri_1(3,1,i),tri_1(4,1,i),
     &   tri_1(5,1,i),tri_1(6,1,i),tri_1(7,1,i),tri_1(8,1,i),
     &	 tri_1(9,1,i),tri_1(10,1,i),tri_1(11,1,i),tri_1(12,1,i)
		 read(32,30)tri_1(1,2,i),tri_1(2,2,i),tri_1(3,2,i),tri_1(4,2,i),
     &   tri_1(5,2,i),tri_1(6,2,i),tri_1(7,2,i),tri_1(8,2,i),
     &	 tri_1(9,2,i),tri_1(10,2,i),tri_1(11,2,i),tri_1(12,2,i)
		 read(32,30)tri_1(1,3,i),tri_1(2,3,i),tri_1(3,3,i),tri_1(4,3,i),
     &   tri_1(5,3,i),tri_1(6,3,i),tri_1(7,3,i),tri_1(8,3,i),
     &	 tri_1(9,3,i),tri_1(10,3,i),tri_1(11,3,i),tri_1(12,3,i)
	 
         read(32,30)tri_2(1,1,i),tri_2(2,1,i),tri_2(3,1,i),tri_2(4,1,i),
     &   tri_2(5,1,i),tri_2(6,1,i),tri_2(7,1,i),tri_2(8,1,i),
     &	 tri_2(9,1,i),tri_2(10,1,i),tri_2(11,1,i),tri_2(12,1,i)
		 read(32,30)tri_2(1,2,i),tri_2(2,2,i),tri_2(3,2,i),tri_2(4,2,i),
     &   tri_2(5,2,i),tri_2(6,2,i),tri_2(7,2,i),tri_2(8,2,i),
     &	 tri_2(9,2,i),tri_2(10,2,i),tri_2(11,2,i),tri_2(12,2,i)
		 read(32,30)tri_2(1,3,i),tri_2(2,3,i),tri_2(3,3,i),tri_2(4,3,i),
     &   tri_2(5,3,i),tri_2(6,3,i),tri_2(7,3,i),tri_2(8,3,i),
     &	 tri_2(9,3,i),tri_2(10,3,i),tri_2(11,3,i),tri_2(12,3,i) 
	 
	    enddo
		
	    close(32)
		
c       this is the first main loop, where triple points on layer 1
c       are matched with points on the second layer
		counter=0
		
		do i=1,n_1

c  we start by finding the coordinate of the triple junction on the first layer.   
c  We know that one of the endpoints of the first segment must match one of the 
c  end points of the second segment.  The match is the tiple point coordinate.		
		
		if(tri_1(9,1,i).eq.tri_1(9,2,i).and.tri_1(10,1,i)
     &	 .eq.tri_1(10,2,i)) then
	      tl(1,i)=tri_1(9,1,i)
		  tl(2,i)=tri_1(10,1,i)
		  goto 35
		endif
		 
        if(tri_1(9,1,i).eq.tri_1(11,2,i).and.tri_1(10,1,i)
     &	 .eq.tri_1(12,2,i)) then
	      tl(1,i)=tri_1(9,1,i)
		  tl(2,i)=tri_1(10,1,i)
		  goto 35
		endif	
c if the first coodinate doesn't match either of those from the second segment,
c then the second coordinate must be the triple point.
		
		tl(1,i)=tri_1(11,1,i)
		tl(2,i)=tri_1(12,1,i)

 35     continue
 
c now we repeat the step above for the junction on the second layer
c the logic is the same as above.
 
  		if(tri_2(9,1,i).eq.tri_2(9,2,i).and.tri_2(10,1,i)
     &	 .eq.tri_2(10,2,i)) then
	      tl(3,i)=tri_2(9,1,i)
		  tl(4,i)=tri_2(10,1,i)
		  goto 36
		endif
		 
        if(tri_2(9,1,i).eq.tri_2(11,2,i).and.tri_2(10,1,i)
     &	 .eq.tri_2(12,2,i)) then
	      tl(3,i)=tri_2(9,1,i)
		  tl(4,i)=tri_2(10,1,i)
		  goto 36
		endif	
		
		tl(3,i)=tri_2(11,1,i)
		tl(4,i)=tri_2(12,1,i)

 36     continue
 
c  Now that we know the coordinates of the triple line, we re-order
c  the data so that the first coordinate of each segment is the triple 
c  line coordinate.

		do j=1,3

  		if(tri_1(9,j,i).ne.tl(1,i).or.tri_1(10,j,i) 
     &	 .ne.tl(2,i)) then 
         temp1=tri_1(9,j,i)
		 temp2=tri_1(10,j,i)
         tri_1(9,j,i)=tl(1,i)
         tri_1(10,j,i)=tl(2,i)
		 tri_1(11,j,i)=temp1
		 tri_1(12,j,i)=temp2
		else 
         continue
		endif
		
  		if(tri_2(9,j,i).ne.tl(3,i).or.tri_2(10,j,i) 
     &	 .ne.tl(4,i)) then 
         temp1=tri_2(9,j,i)
		 temp2=tri_2(10,j,i)
         tri_2(9,j,i)=tl(3,i)
         tri_2(10,j,i)=tl(4,i)
		 tri_2(11,j,i)=temp1
		 tri_2(12,j,i)=temp2
		else 
         continue
		endif		 
        
		enddo   !this is the j loop
				
c  next, we have to order the segments in the same fashion, cw or ccw.  
c  To do this, we arbitrarily choose the first segment on the top layer as the reference
c  direction, v1.  The other two are labled v2 and v3.  If the cross product of
c  v1 and v2 points up (has a positive z component), then it is within pi radians
c  of V1 in the counter clockwise direction.  If the cross product gives the opposite result, 
c  then it is with pi radians of v1 in the cw direction.  Depending on which order you want,
c  you either switch lines 2 and 3 or keep them the same (see 'one way' and 'other way') 
c  if both crosses point in the same direction, it is more complicated.
c  The code to sort this has not yet been developed.

        v1(1)=tri_1(11,1,i)-tri_1(9,1,i)
        v1(2)=tri_1(12,1,i)-tri_1(10,1,i)
		v1(3)=0.0

        v2(1)=tri_1(11,2,i)-tri_1(9,2,i)
        v2(2)=tri_1(12,2,i)-tri_1(10,2,i)
		v2(3)=0.0 

        v3(1)=tri_1(11,3,i)-tri_1(9,3,i)
        v3(2)=tri_1(12,3,i)-tri_1(10,3,i)
		v3(3)=0.0 

c  at this point, only the third component of the cross product is relevant

        cross1=(v1(1)*v2(2))-(v2(1)*v1(2))
		cross2=(v1(1)*v3(2))-(v3(1)*v1(2))

         if(cross1.ge.0.0.and.cross2.ge.0.0) then
c		 calculate both angles and see which is closer
c		 this is the ccw segment and should be the second one
         !write(6,*) 'both crosses are positive',i
		 bad=bad+1
		  if (keep.eq.0) then
		   goto 3000
		  else 
		   goto 2000
		  endif  
		else
		 continue
		endif  
		
         if(cross1.le.0.0.and.cross2.le.0.0) then
c		 calculate both angles and see which is further
c		 this is the ccw one and should be second
         !write(6,*) 'both crosses are negative',i
		 bad=bad+1
		  if (keep.eq.0) then
		   goto 3000
		  else 
		   goto 2000
		  endif  
		else
		 continue
		endif  

         if(cross1.ge.0.0.and.cross2.le.0) then  ! One way
c        if(cross1.le.0.0.and.cross2.ge.0) then  ! opposite way
		 do j=1,12                   ! here we swtich segments 2 and 3
		  temp_l(j)=tri_1(j,3,i)
		 enddo
		 do j=1,12
		  tri_1(j,3,i)=tri_1(j,2,i)
		  tri_1(j,2,i)=temp_l(j)
		 enddo
		 
		else
		 continue
		endif  




c       the next step is to order the Euler angles so that the three angles
c       in the first position of each line are are uniquely associated with 
c       that line segment.		

c       Let's assign the orientation shared by 1 and 2 to be associated with 1.

        if (tri_1(1,1,i).ne.tri_1(1,2,i).and.tri_1(2,1,i).ne.  !if true, then the second
     &  tri_1(2,2,i).and.tri_1(1,1,i).ne.tri_1(4,2,i).and.     !set on the first line are
     &  tri_1(2,1,i).ne.tri_1(5,2,i)) then                     !the unique ones.
	      temp1=tri_1(1,1,i)                                   !these statements make the switch
		  temp2=tri_1(2,1,i)
		  temp3=tri_1(3,1,i)
		  tri_1(1,1,i)=tri_1(4,1,i)
		  tri_1(2,1,i)=tri_1(5,1,i)
		  tri_1(3,1,i)=tri_1(6,1,i)
		  tri_1(4,1,i)=temp1
		  tri_1(5,1,i)=temp2
		  tri_1(6,1,i)=temp3
	    else
		  continue
		endif       

c       Let's assign the orientation shared by 2 and 3 to be associated with 2.

        if (tri_1(1,2,i).ne.tri_1(1,3,i).and.tri_1(2,2,i).ne.  !if true, then the second
     &  tri_1(2,3,i).and.tri_1(1,2,i).ne.tri_1(4,3,i).and.     !set on the second line are
     &  tri_1(2,2,i).ne.tri_1(5,3,i)) then                     !the unique ones.
	      temp1=tri_1(1,2,i)                                   !these statements make the switch
		  temp2=tri_1(2,2,i)
		  temp3=tri_1(3,2,i)
		  tri_1(1,2,i)=tri_1(4,2,i)
		  tri_1(2,2,i)=tri_1(5,2,i)
		  tri_1(3,2,i)=tri_1(6,2,i)
		  tri_1(4,2,i)=temp1
		  tri_1(5,2,i)=temp2
		  tri_1(6,2,i)=temp3
	    else
		  continue
		endif  

c       Let's assign the orientation shared by 3 and 1 to be associated with 3.

        if (tri_1(1,3,i).ne.tri_1(1,1,i).and.tri_1(2,3,i).ne.  !if true, then the second
     &  tri_1(2,1,i).and.tri_1(1,3,i).ne.tri_1(4,1,i).and.     !set on the third line are
     &  tri_1(2,3,i).ne.tri_1(5,1,i)) then                     !the unique ones.
	      temp1=tri_1(1,3,i)                                   !these statements make the switch
		  temp2=tri_1(2,3,i)
		  temp3=tri_1(3,3,i)
		  tri_1(1,3,i)=tri_1(4,3,i)
		  tri_1(2,3,i)=tri_1(5,3,i)
		  tri_1(3,3,i)=tri_1(6,3,i)
		  tri_1(4,3,i)=temp1
		  tri_1(5,3,i)=temp2
		  tri_1(6,3,i)=temp3
	    else
		  continue
		endif 
        


c       Now we have to order the second three lines so that they have the
c       same order as the first three lines.  If the segments coorrespond
c       to each other, the misorientations between the Euler angles should
c       be a minimum.

c       Starting with the first segment on the top layer, we find the matching
c       line on the second layer by computing all of the disorientations
        nit=0
 150       continue
        nit=nit+1
		if(nit.gt.10) then
			write(6,*)'bad TJ at',i
		    goto 3000 !this catches infinite loops that can develop if 
        endif         !false TJ sneaks into the list
 		do j=1,6                
		 do k=1,6
		  min_disor(j,k)=pi/2.0
		 enddo
		enddo 

c       assign the Euler angles
		do k=1,3
         e1_1(k)=tri_1(k,1,i)
		 e1_2(k)=tri_1(k+3,1,i)
		 e1_3(k)=tri_1(k,2,i)
		 e1_4(k)=tri_1(k+3,2,i)
		 e2_1(k)=tri_2(k,1,i)
		 e2_2(k)=tri_2(k+3,1,i)
		 e2_3(k)=tri_2(k,2,i)
		 e2_4(k)=tri_2(k+3,2,i)
		 e2_5(k)=tri_2(k,3,i)
		 e2_6(k)=tri_2(k+3,3,i)		 
		enddo

c        the converts the Euler angles to orientations
         call EToG(e1_1,g1_1)
		 call EToG(e1_2,g1_2)
         call EToG(e1_3,g1_3)
		 call EToG(e1_4,g1_4)		 
		 call EToG(e2_1,g2_1)
		 call EToG(e2_2,g2_2) 
		 call EToG(e2_3,g2_3)
		 call EToG(e2_4,g2_4) 
		 call EToG(e2_5,g2_5)
		 call EToG(e2_6,g2_6) 

c        calculate disorientations between 1_1 and all the
c        six on the second layer, then 1_2 and the six on the second layer.

		   do i_s=1,nsymm	  	!1_1 and 2_1
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_1,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,1)) then
				min_disor(1,1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,1)) then
				min_disor(1,1)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_1 and 2_2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,2)) then
				min_disor(1,2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,2)) then
				min_disor(1,2)=misor
			   endif 
           enddo
		  enddo		  
		  
		   do i_s=1,nsymm	  	!1_1 and 2_3
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_3,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,3)) then
				min_disor(1,3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,3)) then
				min_disor(1,3)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_1 and 2_4
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_4,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,4)) then
				min_disor(1,4)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,4)) then
				min_disor(1,4)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_1 and 2_5
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_5,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,5)) then
				min_disor(1,5)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,5)) then
				min_disor(1,5)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_1 and 2_6
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_1,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_6,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,6)) then
				min_disor(1,6)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(1,6)) then
				min_disor(1,6)=misor
			   endif 
           enddo
		  enddo			  
		  
		  

		   do i_s=1,nsymm	  	!1_2 and 2_1
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_1,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,1)) then
				min_disor(2,1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,1)) then
				min_disor(2,1)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_2 and 2_2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,2)) then
				min_disor(2,2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,2)) then
				min_disor(2,2)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_2 and 2_3
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_3,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,3)) then
				min_disor(2,3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,3)) then
				min_disor(2,3)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_2 and 2_4
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_4,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,4)) then
				min_disor(2,4)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,4)) then
				min_disor(2,4)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_2 and 2_5
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_5,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,5)) then
				min_disor(2,5)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,5)) then
				min_disor(2,5)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_2 and 2_6
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_2,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_6,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,6)) then
				min_disor(2,6)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(2,6)) then
				min_disor(2,6)=misor
			   endif 
           enddo
		  enddo		
		  
		  

c        calculate disorientations between 2_1 and all the
c        six on the second layer, then 2_2 and the six on the second layer.

		   do i_s=1,nsymm	  	!1_3 and 2_1
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_1,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,1)) then
				min_disor(3,1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,1)) then
				min_disor(3,1)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_3 and 2_2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,2)) then
				min_disor(3,2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,2)) then
				min_disor(3,2)=misor
			   endif 
           enddo
		  enddo		  
		  
		   do i_s=1,nsymm	  	!1_3 and 2_3
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_3,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,3)) then
				min_disor(3,3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,3)) then
				min_disor(3,3)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_3 and 2_4
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_4,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,4)) then
				min_disor(3,4)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,4)) then
				min_disor(3,4)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_3 and 2_5
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_5,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,5)) then
				min_disor(3,5)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,5)) then
				min_disor(3,5)=misor
			   endif 
           enddo
		  enddo
		  
		   do i_s=1,nsymm	  	!1_3 and 2_6
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_3,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_6,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,6)) then
				min_disor(3,6)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(3,6)) then
				min_disor(3,6)=misor
			   endif 
           enddo
		  enddo			  
		  
		  

		   do i_s=1,nsymm	  	!1_4 and 2_1
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_1,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,1)) then
				min_disor(4,1)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,1)) then
				min_disor(4,1)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_4 and 2_2
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_2,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,2)) then
				min_disor(4,2)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,2)) then
				min_disor(4,2)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_4 and 2_3
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_3,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,3)) then
				min_disor(4,3)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,3)) then
				min_disor(4,3)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_4 and 2_4
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_4,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,4)) then
				min_disor(4,4)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,4)) then
				min_disor(4,4)=misor
			   endif 
           enddo
		  enddo		  

		   do i_s=1,nsymm	  	!1_4 and 2_5
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_5,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,5)) then
				min_disor(4,5)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,5)) then
				min_disor(4,5)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_4 and 2_6
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_4,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_6,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,6)) then
				min_disor(4,6)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(4,6)) then
				min_disor(4,6)=misor
			   endif 
           enddo
		  enddo	

!  Now, all possible disorientations are computed, figure out matches  
!          write(6,*) 'start',i

c          if (i.eq.234) then
c		   write(6,*) min_disor(1,1), min_disor(1,2)
c		   write(6,*) min_disor(1,3), min_disor(1,4)
c		   write(6,*) min_disor(1,5), min_disor(1,6)		   
c		   write(6,*) min_disor(2,1), min_disor(2,2)
c		   write(6,*) min_disor(2,3), min_disor(2,4)		   
c		   write(6,*) ' '
c		  endif 
		   
          if (min_disor(1,1).lt.0.0873.and.min_disor(2,2).lt.0.0873.
     &    or.min_disor(2,1).lt.0.0873.and.min_disor(1,2).lt.0.0873) then 
            !first on first matches first on second, do nothing
c          if (i.eq.234) then
c			write(6,*)'first lines match'
c		  endif	
		   goto 500
		  endif	
			
          if (min_disor(1,3).lt.0.0873.and.min_disor(2,4).lt.0.0873.
     &    or.min_disor(2,3).lt.0.0873.and.min_disor(1,4).lt.0.0873) then
            !first on first matches second on second
c            if (i.eq.234) then			
c			write(6,*)'switch 1 and 2'
c			endif
		  do j=1,12                   ! here we switch segments 2 and 1
		   temp_l(j)=tri_2(j,1,i)
		  enddo
		  do j=1,12
		   tri_2(j,1,i)=tri_2(j,2,i)
		   tri_2(j,2,i)=temp_l(j)
		  enddo
          goto 150
		  endif
				  	  
          if (min_disor(1,5).lt.0.0873.and.min_disor(2,6).lt.0.0873.
     &    or.min_disor(2,5).lt.0.0873.and.min_disor(1,6).lt.0.0873) then
            !first on first matches third on second			
c          if (i.eq.234) then
c			write(6,*)'switch 1 and 3'  
c          endif
		  do j=1,12                   ! here we switch segments 3 and 1
		   temp_l(j)=tri_2(j,1,i)
		  enddo
		  do j=1,12
		   tri_2(j,1,i)=tri_2(j,3,i)
		   tri_2(j,3,i)=temp_l(j)
		  enddo
		  goto 150
		  endif
		  
 500	  continue
c		  if (i.eq.2) then
c	       write(6,*)min_disor(3,3), min_disor(4,4), min_disor(3,4), min_disor(4,3)
c		  endif
c		  if (i.eq.9) then
c	       write(6,*)min_disor(3,3), min_disor(4,4), min_disor(3,4), min_disor(4,3)
c		   write(6,*)e1_3(1)-e2_3(1),e1_4(1)-e2_4(1),e1_3(1)-e2_4(1),e1_4(1)-e2_3(1)
c		  endif
		  
          if (min_disor(3,3).lt.0.0873.and.min_disor(4,4).lt.0.0873.
     &    or.min_disor(3,4).lt.0.0873.and.min_disor(4,3).lt.0.0873) then
	 	 
            !second on first matches second on second

c           if (i.eq.234) then
c			write(6,*)'second layers match',i
c           endif
		   goto 1000
		   else
c		   if (i.eq.234) then
c			write(6,*)'second and third layers switched',i
c		   endif 
		   do j=1,12                   ! here we switch segments 3 and 2
		   temp_l(j)=tri_2(j,2,i)
		  enddo
		  do j=1,12
		   tri_2(j,2,i)=tri_2(j,3,i)
		   tri_2(j,3,i)=temp_l(j)
		  enddo		   
		   goto 150
		   endif
				  	   		  
 1000     continue		  
		  !write(6,*) 'write',i
		  !that should do it
		  
		  ! now, as a final step. we need to order the two sets
		  ! sets of Euler angle on the second layer so that the
		  ! match the order on the first layer

        if (min_disor(1,1).gt.0.0873.and.min_disor(2,2).gt.    !if true, then switch  
     &  0.0873) then                     
	      temp1=tri_2(1,1,i)                                   !these statements make the switch
		  temp2=tri_2(2,1,i)
		  temp3=tri_2(3,1,i)
		  tri_2(1,1,i)=tri_2(4,1,i)
		  tri_2(2,1,i)=tri_2(5,1,i)
		  tri_2(3,1,i)=tri_2(6,1,i)
		  tri_2(4,1,i)=temp1
		  tri_2(5,1,i)=temp2
		  tri_2(6,1,i)=temp3
	    else
		  continue
		endif       

        if (min_disor(3,3).gt.0.0873.and.min_disor(4,4).gt.    !if true, then switch  
     &  0.0873) then                      
	      temp1=tri_2(1,2,i)                                   !these statements make the switch
		  temp2=tri_2(2,2,i)
		  temp3=tri_2(3,2,i)
		  tri_2(1,2,i)=tri_2(4,2,i)
		  tri_2(2,2,i)=tri_2(5,2,i)
		  tri_2(3,2,i)=tri_2(6,2,i)
		  tri_2(4,2,i)=temp1
		  tri_2(5,2,i)=temp2
		  tri_2(6,2,i)=temp3
	    else
		  continue
		endif  
		
		! We need the last two disorientations that we did not already compute
		
c       assign the Euler angles
		do k=1,3
		 e1_5(k)=tri_1(k,3,i)
		 e1_6(k)=tri_1(k+3,3,i)		 
		enddo

c        the converts the Euler angles to orientations

		 call EToG(e1_5,g1_5)
		 call EToG(e1_6,g1_6) 		
		
		
				   do i_s=1,nsymm	  	!1_5 and 2_5
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_5,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_5,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(5,5)) then
				min_disor(5,5)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(5,5)) then
				min_disor(5,5)=misor
			   endif 
           enddo
		  enddo			  
	
		  do i_s=1,nsymm	  	!1_6 and 2_6
		    call symop(O,i_s,so1)
		    call MToM (so1,g1_6,gg1)
			do j_s=1,nsymm
		     call symop(O,j_s,so2)
		     call MToM(so2,g2_6,gg2)
		     call trans(gg2,gt)
		     call MToM(gg1,gt,dg)
			   misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(6,6)) then
				min_disor(6,6)=misor
			   endif 	
		   call trans (gg1, gt)		   
		   call MToM (gg2, gt, dg)
		   		misor=acos((dg(1,1)+dg(2,2)+dg(3,3)-1.0)/2.0)
               if (misor.lt.min_disor(6,6)) then
				min_disor(6,6)=misor
			   endif 
           enddo
		  enddo	

		

        if (min_disor(5,5).gt.0.0873.and.min_disor(6,6).gt.    !if true, then switch  
     &  0.0873) then 
	      temp1=tri_2(1,3,i)                                   !these statements make the switch
		  temp2=tri_2(2,3,i)
		  temp3=tri_2(3,3,i)
		  tri_2(1,3,i)=tri_2(4,3,i)
		  tri_2(2,3,i)=tri_2(5,3,i)
		  tri_2(3,3,i)=tri_2(6,3,i)
		  tri_2(4,3,i)=temp1
		  tri_2(5,3,i)=temp2
		  tri_2(6,3,i)=temp3
	    else
		  continue
		endif 
        		  
		  
		  
		  
		  
		  
		  

 
 1100     format(f5.2,1x,f5.2,1x,f5.2,1x,f5.2,1x,f5.0,1x,f5.0)
 2000    continue

		 write(39,30)tri_1(1,1,i),tri_1(2,1,i),tri_1(3,1,i),tri_1(4,1,i),
     &   tri_1(5,1,i),tri_1(6,1,i),tri_1(7,1,i),tri_1(8,1,i),
     &	 tri_1(9,1,i),tri_1(10,1,i),tri_1(11,1,i),tri_1(12,1,i)
		 write(39,30)tri_1(1,2,i),tri_1(2,2,i),tri_1(3,2,i),tri_1(4,2,i),
     &   tri_1(5,2,i),tri_1(6,2,i),tri_1(7,2,i),tri_1(8,2,i),
     &	 tri_1(9,2,i),tri_1(10,2,i),tri_1(11,2,i),tri_1(12,2,i)
		 write(39,30)tri_1(1,3,i),tri_1(2,3,i),tri_1(3,3,i),tri_1(4,3,i),
     &   tri_1(5,3,i),tri_1(6,3,i),tri_1(7,3,i),tri_1(8,3,i),
     &	 tri_1(9,3,i),tri_1(10,3,i),tri_1(11,3,i),tri_1(12,3,i)

		 write(39,30)tri_2(1,1,i),tri_2(2,1,i),tri_2(3,1,i),tri_2(4,1,i),
     &   tri_2(5,1,i),tri_2(6,1,i),tri_2(7,1,i),tri_2(8,1,i),
     &	 tri_2(9,1,i),tri_2(10,1,i),tri_2(11,1,i),tri_2(12,1,i)
		 write(39,30)tri_2(1,2,i),tri_2(2,2,i),tri_2(3,2,i),tri_2(4,2,i),
     &   tri_2(5,2,i),tri_2(6,2,i),tri_2(7,2,i),tri_2(8,2,i),
     &	 tri_2(9,2,i),tri_2(10,2,i),tri_2(11,2,i),tri_2(12,2,i)
		 write(39,30)tri_2(1,3,i),tri_2(2,3,i),tri_2(3,3,i),tri_2(4,3,i),
     &   tri_2(5,3,i),tri_2(6,3,i),tri_2(7,3,i),tri_2(8,3,i),
     &	 tri_2(9,3,i),tri_2(10,3,i),tri_2(11,3,i),tri_2(12,3,i)
		 
		 good(i)=good(i)+1

c		 if (i.eq.10) goto 9000

		  v1(1)=tri_1(9,1,i)-tri_2(9,1,i)
		  v1(2)=tri_1(10,1,i)-tri_2(10,1,i)
		  v1(3)=slice
		  


		   length=((v1(1)*v1(1))+(v1(2)*v1(2))+(v1(3)*v1(3)))**0.5

		   
c          now normalize the length of the vector 

 
		   
		   n(1)=v1(1)
		   n(2)=v1(2)
		   n(3)=v1(3)

           tot_x=tot_x+n(1)   !sums x and y components for mean
		   tot_y=tot_y+n(2)
		   
		 r_count=r_count+1


 3000   continue	
		enddo         ! this is the i loop

		mean_x=tot_x/r_count
		mean_y=tot_y/r_count
		 
		write(6,*) r_count    
		write(6,*) 'the mean x and y are:', mean_x, mean_y
		write(56,*) mean_x, mean_y

 
 
		do i=1,n_1
		

		 write(55,30)tri_1(1,1,i),tri_1(2,1,i),tri_1(3,1,i),tri_1(4,1,i),
     &   tri_1(5,1,i),tri_1(6,1,i),tri_1(7,1,i),tri_1(8,1,i),
     &	 (tri_1(9,1,i)-mean_x),(tri_1(10,1,i)-mean_y),
     &	 (tri_1(11,1,i)-mean_x),(tri_1(12,1,i)-mean_y)
		 write(55,30)tri_1(1,2,i),tri_1(2,2,i),tri_1(3,2,i),tri_1(4,2,i),
     &   tri_1(5,2,i),tri_1(6,2,i),tri_1(7,2,i),tri_1(8,2,i),
     &	 (tri_1(9,2,i)-mean_x),(tri_1(10,2,i)-mean_y),
     &	 (tri_1(11,2,i)-mean_x),(tri_1(12,2,i)-mean_y)
		 write(55,30)tri_1(1,3,i),tri_1(2,3,i),tri_1(3,3,i),tri_1(4,3,i),
     &   tri_1(5,3,i),tri_1(6,3,i),tri_1(7,3,i),tri_1(8,3,i),
     &	 (tri_1(9,3,i)-mean_x),(tri_1(10,3,i)-mean_y),
     &	 (tri_1(11,3,i)-mean_x),(tri_1(12,3,i)-mean_y)

		 write(55,30)tri_2(1,1,i),tri_2(2,1,i),tri_2(3,1,i),tri_2(4,1,i),
     &   tri_2(5,1,i),tri_2(6,1,i),tri_2(7,1,i),tri_2(8,1,i),
     &	 tri_2(9,1,i),tri_2(10,1,i),tri_2(11,1,i),tri_2(12,1,i)
		 write(55,30)tri_2(1,2,i),tri_2(2,2,i),tri_2(3,2,i),tri_2(4,2,i),
     &   tri_2(5,2,i),tri_2(6,2,i),tri_2(7,2,i),tri_2(8,2,i),
     &	 tri_2(9,2,i),tri_2(10,2,i),tri_2(11,2,i),tri_2(12,2,i)
		 write(55,30)tri_2(1,3,i),tri_2(2,3,i),tri_2(3,3,i),tri_2(4,3,i),
     &   tri_2(5,3,i),tri_2(6,3,i),tri_2(7,3,i),tri_2(8,3,i),
     &	 tri_2(9,3,i),tri_2(10,3,i),tri_2(11,3,i),tri_2(12,3,i)
		 
		 ok=ok+1

        enddo      ! ends i loop

        r_count=0
		
        enddo                 ! This is the end of the file_n looop
        write(6,*)bad,' bad junctions were ignored'
		write(6,*)ok,' good triple junctions were written to tls.txt'
		
 9000     continue  
          close(39) 

		 close(55)
c		 close(35)
		 close(56)
c		 close(37)
c		 close(38)

		 
        end